Subject: Re: [PATCH] sendfile() and UDP socket

From: Rémi Denis-Courmont <[email-masked]>
Date: Thu, 18 Sep 2008 20:31:00 +0300

Le mardi 16 septembre 2008 15:01:17 Hirokazu Takahashi, vous avez écrit :
> UDP is a datagram protocol, so I think applications using UDP should
> care about the size of packets they are going to send rather than
> expecting that the messages will be split into several packets
> automatically. If some of the packets have lost, it will be really hard for
> the applications to re-create the same ones to send again.

Also, why use UDP for this... If you want stream semantics, why not use TCP or 
SCTP instead?

> If you want send a large file over UDP, the typical code will be like:

> while (...) {
>         sendmsg(fd, &apl_header, sizeof(apl_header), MSG_MORE);
>         offset += sendfile(fd, offset, count);
> }

Correct me if I am wrong, but... Unless you have a big MTU (as _not_ in 1500 
bytes :D), doing an extra syscall might be slower than copying data in a 
single vectorized sendmsg() syscall.

-- 
Rémi Denis-Courmont
http://www.remlab.net/